// PBuffer.cpp: implementation of the PBuffer class.
//
//////////////////////////////////////////////////////////////////////

// #include "stdafx.h"
#include "PBuffer.h"

/* #ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif */

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PBuffer::PBuffer()
{
	memset ( this , 0x0 , sizeof ( *this ) );
}

PBuffer::~PBuffer()
{
	Clear();
}

bool PBuffer::IsEmpty()
{	
	return ( m_nUsedLength == 0 );
}

void PBuffer::Clear()
{
	if ( m_pBuffer )
	{
		delete[] m_pBuffer;
		m_pBuffer = NULL;
	}
	m_nUsedLength = 0;
	m_nBufferLength = 0;
}

void PBuffer::UsedLength( int nLength )
{
	assert ( 0 <= nLength );
	/* if( nLength <= m_nUsedLength )
	{
		printf( "nLength = %d , nUsedLength = %d" , nLength , m_nUsedLength );
		printf( "Buffer State = %s \n" , m_pBuffer );
	} */
	assert ( nLength <= m_nUsedLength );
	
	m_nUsedLength -= nLength;
	memmove( m_pBuffer, m_pBuffer + nLength, m_nUsedLength );
}

void PBuffer::AddTail( char* pBuffer, int nLength )
{
	if ( NULL == m_pBuffer )
	{
		m_pBuffer = new char[ nLength ];
		memset( m_pBuffer , 0 , nLength );
		
		m_nBufferLength = nLength;
	}
	else
	{
		if( m_nBufferLength - m_nUsedLength < nLength )
		{
			m_nBufferLength += nLength;

			char* pTempBuffer = new char[ m_nBufferLength ];
			memset ( pTempBuffer, 0 , m_nBufferLength );		

			memcpy ( pTempBuffer, m_pBuffer, m_nUsedLength );
			
			delete[] m_pBuffer;
			m_pBuffer = pTempBuffer;
		}
	}

	memcpy( m_pBuffer + m_nUsedLength, pBuffer, nLength );
	m_nUsedLength += nLength;
}
