#ifndef __UNO_IN_OUT_PIN_H__
#define __UNO_IN_OUT_PIN_H__

#include "../include/InOutPin.h"
#include "tree.h"

#define IOP_PARSING_RESULT		IOP_USER + 1
#define IOP_GLOBAL_ANALYSIS_INPUT	IOP_USER + 2
#define IOP_SCRIPT_PARSING_RESULT	IOP_USER + 3

#define PIN_NAME_PARSING_RESULT		"ParsingResultPin"
#define PIN_NAME_SCRIPT_PARSING_RESULT	"ScriptParsingResultPin"
#define PIN_NAME_GLOBAL_ANALYSIS_INPUT  "GlobalAnalysisInputPin"

class CProcessStateInfo
{
public:
	CProcessStateInfo()
	{
		m_nCount = 0;
		m_nCurrentProcessRate;
	}
	virtual ~CProcessStateInfo()
	{
	}

	int m_nCount;
	int m_nCurrentProcessRate;
};

class CParsingResultPin : public CInOutPinBase 
{
public:
	CParsingResultPin()
	{
		m_pParseTree	= NULL;
		m_pOption 	= NULL;

		m_uiId		= IOP_PARSING_RESULT;

		memset( m_szFileName , 0 , sizeof( m_szFileName ) );
	}
	virtual ~CParsingResultPin()
	{
		if( m_pOption )
		{
			delete [] m_pOption;
			m_pOption = NULL;
		}
	}

	treenode* m_pParseTree;

	char m_szFileName[ 128 ];
	char* m_pOption;

	// CProcessStateInfo ProcessStateInfo;
};

class CScriptParsingResultPin : public CInOutPinBase 
{
public:
	CScriptParsingResultPin()
	{
		m_pParseTree	= NULL;
		m_pOption 	= NULL;

		m_uiId		= IOP_SCRIPT_PARSING_RESULT;

		memset( m_szFileName , 0 , sizeof( m_szFileName ) );
	}
	virtual ~CScriptParsingResultPin()
	{
		if( m_pOption )
		{
			delete [] m_pOption;
			m_pOption = NULL;
		}
	}

	treenode* m_pParseTree;

	char m_szFileName[ 128 ];
	char* m_pOption;

	// CProcessStateInfo ProcessStateInfo;
};

class CGlobalAnalysisInputPin : public CInOutPinBase
{
public:
	CGlobalAnalysisInputPin()
	{
		m_ppszArgument	=	NULL;
		m_nArgCount	=	0;
	}
	virtual ~CGlobalAnalysisInputPin()
	{
	}

	char**	m_ppszArgument;
	int	m_nArgCount;
};

#endif

